#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cassert>

//
// You may use all, some, or none of the provided code below in creating your solution.
//

// ========================================================================================

std::string load_courses(const std::string &filename, const std::string &term, int year
                         /* ADD ADDITIONAL VARIABLES HERE */ ) {
  std::ifstream istr(filename);
  assert (istr.good());

  int num, code, capacity, credits;
  std::string dept, section, title, token;
  int start,end;
  char dash;
    
  // Read each line of the input courses file
  while (istr >> num >> dept >> code >> section >> title >> capacity >> credits) {

    // DO SOMETHING WITH: num, dept, code, section, title, capacity, credits

    // loop over the array of meeting times
    istr >> token;
    assert (token == "[");
    while (istr >> token) {
      if (token == "]") break;
      else {
        assert (token.size() == 1);
        char day = token[0];
        istr >> start >> dash >> end;
        assert (dash == '-');

        // DO SOMETHING WITH: day, start, end
        
      }
    }
  }
  
  // return empty string if there are no errors
  return "";
}

// ========================================================================================

std::string load_prereqs(const std::string &filename
                         /* ADD ADDITIONAL VARIABLES HERE */ ) {
  std::ifstream istr(filename);
  assert (istr.good());

  std::string dept,dept2,title,title2,token;
  int code,code2;

  // loop over each course in the prereqs file
  while (istr >> dept >> code >> title) {
    istr >> token; assert (token == "has");
    istr >> token; assert (token == "prereqs:");
    istr >> token; assert (token == "[");
    while (istr >> token) {
      if (token == "]") break;
      if (token == ",") continue;
      dept2 = token;
      istr >> code2 >> title2;

      // DO SOMETHING WITH: dept, code, title, dept2, code2, title2
      
    }
  }
  
  // return empty string if there are no errors
  return "";
}

// ========================================================================================

std::string load_degree_requirements(const std::string &filename
                                     /* ADD ADDITIONAL VARIABLES HERE */ ) {
  std::ifstream istr(filename);
  assert (istr.good());

  std::string major, dept, token;
  int code;

  // loop over the majors in the input file
  while (istr >> major) {
    istr >> token;
    assert (token == "[");

    // read each of the required courses for this major
    while (istr >> dept >> code) {

      //
      // NOTE: THIS IS EXTRA CREDIT
      //
      // DO SOMETHING WITH: major, dept, code
      //

      istr >> token;
      if (token == "]")
        break;
      if (token == ",")
        continue;
      return "ERROR: Unable to parse degree requirements";
    }
  }

  // return empty string if there are no errors
  return "";
}

// ========================================================================================

std::string enroll_student(const std::string &student, const std::string &major, int credit_limit
                           /* ADD ADDITIONAL VARIABLES HERE */ ) {

  // ADD YOUR IMPLEMENTATION HERE

  // return empty string if there are no errors
  return "";
}

// ========================================================================================

std::string register_for_course(const std::string &student, const std::string &term, int year, int crn
                                /* ADD ADDITIONAL VARIABLES HERE */ ) {

  // ADD YOUR IMPLEMENTATION HERE

  // return empty string if there are no errors
  return "";
}

// ========================================================================================

std::string print_student_registration(const std::string &student
                                       /* ADD ADDITIONAL VARIABLES HERE */ ) {

  // MODIFY THIS FUNCTION AS NECESSARY

  // placeholder
  int total_credit = -1; 
  
  std::cout << "================================================================" << std::endl;
  std::cout << "STUDENT: " << student << "   total credits: " << total_credit << " / 128" << std::endl;

  // loop over each term...

  {
    std::cout << "----------------------------------------------------------------" << std::endl;

    // placeholders
    std::string term = "TERM";
    int year = 9999;
    int cred = -1;
 
    std::cout << term << " " << year << "\n" << std::endl;

    // loop over every course...
    {
      std::string dept = "DEPT";
      int code = 3333;
      std::string section = "00";
      std::string title = "placeholder";
      std::cout << dept << " " << code << " " << section << " " << title << std::endl;
    }
    std::cout << cred << " credit(s)\n";

    // print the weekly schedule grid
    std::cout << "\n       Monday      Tuesday     Wednesday   Thursday    Friday" << std::endl;
    std::vector<std::string> days = {"M","T","W","R","F"};

    // placeholder -- replace with the earliest meeting start time
    int earliest = 800;  
    // placeholder -- replace with the latest meeting end time
    int latest = 1830;   

    for (int h = earliest; h < latest; h+=30) {
      if (h % 100 == 60) { h += 10; continue; }
      std::cout << std::right << std::setw(4) << h << "   ";
      for (unsigned int d = 0; d < days.size(); d++) {

        // replace with the class at this time slot (if any)
        std::string which = "DEPT ####";
        std::cout << std::left << std::setw(12) << which;
        
      }
      std::cout << std::endl;
    }
  }
  std::cout << "================================================================" << std::endl;
  
  // return empty string if there are no errors  
  return "";
}

// ========================================================================================

std::string degree_clearance(const std::string &student
                             /* ADD ADDITIONAL VARIABLES HERE */ ) {

  //
  // NOTE: THIS IS EXTRA CREDIT
  //
  // ADD YOUR IMPLEMENTATION HERE
  //

  // return empty string if there are no errors
  return "";
}

// ========================================================================================

std::string print_course_registration(const std::string& term, int year, const std::string &dept, int code
                                      /* ADD ADDITIONAL VARIABLES HERE */ ) {

  // MODIFY THIS FUNCTION AS NECESSARY

  std::cout << "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" << std::endl;

  // placeholder
  std::string title = "todo: fill in the title..."; 
 
  std::cout << term << " " << year << " " << dept << " " << code << " " << title << std::endl;
  std::cout << std::endl;
  
  std::cout << "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" << std::endl;  

  // return empty string if there are no errors  
  return "";
}

// ========================================================================================
// ========================================================================================
// ========================================================================================

int main() {


  //
  // DECLARE YOUR DATA STRUCTURES HERE
  //


  // parsing helper variables
  std::string term, file, message, major, student, dept, token;
  int year, code, crn;
      
  while ( std::cin >> token ) {
    
    if (token == "load_courses") {
      std::cin >> term >> year >> file;
      message = load_courses(file, term, year /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }
      
    } else if (token == "load_prereqs") {
      std::cin >> file;
      message = load_prereqs(file /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }

    } else if (token == "load_degree_requirements") {
      std::cin >> file;
      // NOTE: EXTRA CREDIT
      message = load_degree_requirements(file /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }
        
    } else if (token == "enroll") {
      int credit_limit;
      std::cin >> student >> major >> credit_limit;
      message = enroll_student(student, major, credit_limit /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }      
      
    } else if (token == "register") {
      std::cin >> student >> term >> year >> crn;
      message = register_for_course(student, term, year, crn /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }
      
    } else if (token == "print_student_registration") {
      std::cin >> student;
      message = print_student_registration(student /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }
      
    } else if (token == "degree_clearance") {
      std::cin >> student;
      // NOTE: EXTRA CREDIT
      message = degree_clearance(student /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }
      
    } else if (token == "print_course_registration") {
      std::cin >> term >> year >> dept >> code;
      message = print_course_registration(term, year, dept, code /* ADD ADDITIONAL VARIABLES HERE */ );
      if (message != "") { std::cerr << message << std::endl; }

    } else {
      std::cerr << "ERROR: UNKNOWN ACTION " << token << std::endl;
      exit(0);
    }
  }
}

// ================================================================================
